From 6fdeeebee00929bdb67031e2a707388dda6e250c Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 17 2020 07:33:49 +0000
Subject: [PATCH 1431/2232] Remove &mut T access from UniquePtr


---

diff --git a/src/unique_ptr.rs b/src/unique_ptr.rs
index 283c2f1..3bb3ed3 100644
--- a/src/unique_ptr.rs
+++ b/src/unique_ptr.rs
@@ -6,7 +6,7 @@ use core::ffi::c_void;
 use core::fmt::{self, Debug, Display};
 use core::marker::PhantomData;
 use core::mem;
-use core::ops::{Deref, DerefMut};
+use core::ops::Deref;
 use core::pin::Pin;
 use core::ptr;
 
@@ -59,10 +59,13 @@ where
         unsafe { T::__get(self.repr).as_ref() }
     }
 
-    /// Returns a mutable reference to the object owned by this UniquePtr if
-    /// any, otherwise None.
-    pub fn as_mut(&mut self) -> Option<&mut T> {
-        unsafe { (T::__get(self.repr) as *mut T).as_mut() }
+    /// Returns a mutable pinned reference to the object owned by this UniquePtr
+    /// if any, otherwise None.
+    pub fn as_mut(&mut self) -> Option<Pin<&mut T>> {
+        unsafe {
+            let mut_reference = (T::__get(self.repr) as *mut T).as_mut()?;
+            Some(Pin::new_unchecked(mut_reference))
+        }
     }
 
     /// Consumes the UniquePtr, releasing its ownership of the heap-allocated T.
@@ -126,18 +129,6 @@ where
     }
 }
 
-impl<T> DerefMut for UniquePtr<T>
-where
-    T: UniquePtrTarget,
-{
-    fn deref_mut(&mut self) -> &mut Self::Target {
-        match self.as_mut() {
-            Some(target) => target,
-            None => panic!("called deref_mut on a null UniquePtr<{}>", T::__NAME),
-        }
-    }
-}
-
 impl<T> Debug for UniquePtr<T>
 where
     T: Debug + UniquePtrTarget,
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 825b13b..ba9383a 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -124,7 +124,7 @@ pub mod ffi {
         fn c_return_primitive() -> usize;
         fn c_return_shared() -> Shared;
         fn c_return_box() -> Box<R>;
-        fn c_return_unique_ptr() -> Pin<UniquePtr<C>>;
+        fn c_return_unique_ptr() -> UniquePtr<C>;
         fn c_return_ref(shared: &Shared) -> &usize;
         fn c_return_mut(shared: &mut Shared) -> &mut usize;
         fn c_return_str(shared: &Shared) -> &str;
diff --git a/tests/ffi/module.rs b/tests/ffi/module.rs
index c8363b6..aff1b1c 100644
--- a/tests/ffi/module.rs
+++ b/tests/ffi/module.rs
@@ -8,6 +8,6 @@ pub mod ffi {
 
         type C = crate::ffi::C;
 
-        fn c_take_unique_ptr(c: Pin<UniquePtr<C>>);
+        fn c_take_unique_ptr(c: UniquePtr<C>);
     }
 }
diff --git a/tests/test.rs b/tests/test.rs
index ff6abd9..da858ff 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -188,11 +188,14 @@ fn test_c_method_calls() {
 
     let old_value = unique_ptr.get();
     assert_eq!(2020, old_value);
-    assert_eq!(2021, unique_ptr.as_mut().set(2021));
+    assert_eq!(2021, unique_ptr.as_mut().unwrap().set(2021));
     assert_eq!(2021, unique_ptr.get());
     assert_eq!(2021, unique_ptr.get2());
-    assert_eq!(2022, unique_ptr.as_mut().set_succeed(2022).unwrap());
-    assert!(unique_ptr.as_mut().get_fail().is_err());
+    assert_eq!(
+        2022,
+        unique_ptr.as_mut().unwrap().set_succeed(2022).unwrap(),
+    );
+    assert!(unique_ptr.as_mut().unwrap().get_fail().is_err());
     assert_eq!(2021, ffi::Shared { z: 0 }.c_method_on_shared());
 }
 

